using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;

namespace ConsoleApplicationLeftRightGame
{
    class Program
    {
        static void Main(string[] args)
        {
            BinTreeNode <int> gameBoard = BinTreeUtils.BuildRandomTree(20, 10, 50);
            //BinTreeUtils.ShowTree(gameBoard, "Left-Right Game");
            PlayLeftRight(gameBoard, 10);
            Console.ReadLine();
        }
        public static void PlayLeftRight(BinTreeNode<int> tree, int n)
	    {
            Random rnd = new Random();
            //   
		    Player[] players = new Player[n];
		    for (int i = 0; i < players.Length; i++) 
			    players[i] = new Player(i+1);
    		
		    for (int i = 0; i < players.Length; i++) 
		    {
			    BinTreeNode<int> runner = tree;
			    players[i].UpdateScore(runner.GetInfo());
			    Console.WriteLine("Player #"+(i+1)+" start to play! ");
			    while(!BinTreeUtils.IsLeaf(runner))
			    {
				    if( rnd.Next(3) == 0)
				    {
					    Console.Write("\ttry to go left: ");
					    if(runner.GetLeft() == null)
					    {
						    players[i].UpdateScore(-3);
						    Console.Write("node not found -3. ");
					    }
					    else
					    {
						    runner = runner.GetLeft();
						    players[i].UpdateScore(runner.GetInfo());
						    Console.Write("node found +"+runner.GetInfo()+". ");
					    }
				    }
				    else
				    {
					    Console.Write("\ttry to go right: ");
					    if(runner.GetRight() == null)
					    {
						    players[i].UpdateScore(-3);
						    Console.Write("node not found -3. ");
					    }
					    else
					    {
						    runner = runner.GetRight();
						    players[i].UpdateScore(runner.GetInfo());
						    Console.Write("node found +"+runner.GetInfo()+". ");
					    }
				    }
                    Console.WriteLine("temp score: " + players[i].GetScore());
			    }
			    Console.WriteLine("\tfinish to play!");
			    Console.WriteLine();
		    }
    		
    		
		    //      
		    for (int i = 1; i < players.Length; i++)
		    {
			    for (int j = 0; j < players.Length-i; j++) 
			    {
				    if(players[j].GetScore()<players[j+1].GetScore())
				    {
					    Player tmp = players[j];
					    players[j] = players[j+1];
					    players[j+1] = tmp;
				    }
			    }
		    }
    		
		    //        
            Console.WriteLine("Total players scores:");
		    for (int i = 0; i < players.Length; i++)
                Console.WriteLine(players[i]);
	    }
    }
}
